#include "dicelib.h"
#include <stdio.h>
#include <GL/glut.h>

int deg = 0;
int winW = 320, winH = 240;

int front (void *data) {
	return 0;
}
int left (void *data) {
	glRotated(90, 0, -1, 0);
	return 0;
}
int right (void *data) {
	glRotated(90, 0, 1, 0);
	return 0;
}
int back (void *data) {
	glRotated(180, 0, -1, 0);
	return 0;
}

DICE_Function DICE_MyFunctions[] = {
	{ "front", front },
	{ "left", left },
	{ "right", right },
	{ "back", back },
	{ NULL, NULL }
};
DICE_no_types;

void glutDisplay (void) {
	const GLfloat colors[3][4] = {  { 1.0, 0.0, 0.0, 1.0 },
					{ 0.0, 1.0, 0.0, 1.0 },
					{ 0.0, 0.0, 1.0, 1.0 } };
	GLfloat white[4] = {1., 1., 1., 1.};
	int i = 0, j;

	/* send updates, synchronize and update variables */
	DICE_sync();

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	/* draw the balls */
	for (i = 60; i >= -60; i -= 20 ) 
		for ( j = 0; j < 3; j++ )  {
			glPushMatrix();
			/* apply the rotation */
			glRotated((deg+j*120)%360, 0, 1, 0);

			glTranslatef(0, i, -50);

			glMaterialfv(GL_FRONT, GL_SPECULAR, white);
			glMaterialf(GL_FRONT, GL_SHININESS, 20.);
			glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, colors[j]);
			glutSolidSphere(8.0, 10.0, 10.0);
			glPopMatrix();
		}

	glutSwapBuffers();
}


void glutIdle (void) {
	static int start = 0;
	int end;
	deg += 1;

	if (deg > 360)
		deg = 0;

#define BENCHMARK
#ifdef BENCHMARK
	if (!deg) {
		end = glutGet(GLUT_ELAPSED_TIME);
		fprintf(stderr, "%d ms, %f fps\n", end-start, 360000.0/(float)(end-start));
		start = end;
	}
#endif
	glutPostRedisplay();
}


void glutResize (int w, int h) {
	const GLfloat light_pos[4] = {10.0,16.0,0.0,0.0};
	winW = w;
	winH = h;

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glViewport(0, 0, winW, winH);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(90, winW / winH, 1, 9999);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	DICE_function(NULL); /* rotate */
	glLightfv(GL_LIGHT0, GL_POSITION, light_pos);
	glutPostRedisplay();
}

void glutKeyboard (unsigned char key, int x, int y) {
	switch (key) {
		case 'q':
		case 'Q':
			DICE_close();
			exit(1);
		default:
			break;
	}
}


int main (int argc, char **argv) { 

	/* init DICElib */
	DICE_init(&argc, argv);

	/* synchronize everybody, making the new variables valid */
	DICE_sync();

	glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
	glutInitWindowSize(winW, winH);
	glutCreateWindow("tt");
	glutIdleFunc(glutIdle);
	glutReshapeFunc(glutResize);
	glutDisplayFunc(glutDisplay);
	glutKeyboardFunc(glutKeyboard);

	/* setup environment */
//	glEnable(GL_BLEND);
//	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_DEPTH_TEST);
//	glDisable(GL_DITHER);
	glEnable(GL_CULL_FACE);
//	glCullFace(GL_BACK);
//	glFrontFace(GL_CCW);

	/* Set up light0 */
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
//	glLightfv(GL_LIGHT0, GL_DIFFUSE, white);
//	glLightfv(GL_LIGHT0, GL_SPECULAR, white);

	/* ambient and diffuse will track glColor */
/*	glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE);
	glEnable(GL_COLOR_MATERIAL);
	glMaterialfv(GL_FRONT, GL_SPECULAR, white);
	glMaterialf(GL_FRONT, GL_SHININESS, 20.); */

	glutMainLoop();
}
