#include "dicelib.h"
#include <stdio.h>
#include <stdlib.h>

DICE_no_functions;

#define VEC_SIZE 1000000

/* packs a VEC_SIZE float vector */
char *longvec_pack	( void *data, int *n ) {
	char			*buf, *t;
	long			*vec;
	int			m, i;

	vec = (long *)data;
	buf = (char *)malloc(VEC_SIZE*sizeof(long));

	if ( !buf )
		return NULL;
	for ( i = 0; i < VEC_SIZE; i++ ) {
		t = DICE_type_pack("signed_long", (void *)&vec[i], &m);
		memcpy(buf+i*4, t, 4);
		free(t);
	}
	*n = 4*VEC_SIZE;
	return buf;
}
/* unpacks a 3 float vector */
void *longvec_unpack	( char *data, int *n ) {
	long			*vec, *f;
	int			m, i;
	
	vec = (long *)malloc(VEC_SIZE*sizeof(long));
	if ( !vec )
		return NULL;
	for ( i = 0; i < VEC_SIZE; i++ ) {
		f = (long *)DICE_type_unpack("signed_long", data, &m);
		vec[i] = *f;
		free(f);
	}
	*n = 4*VEC_SIZE;
	return (void *)vec;
}
/* frees the vector */
void longvec_free		( void *data ) {
	if ( data )
		free(data);
}

DICE_Type DICE_MyTypes[] = {
	{ "longvec", longvec_pack, longvec_unpack, longvec_free },
	{ NULL, NULL, NULL, NULL }
};

int main(int argc, char *argv[]) {
	long f[VEC_SIZE], *g;
	int i, j, max;

	DICE_init(&argc, argv);

	for ( i = 0; i < VEC_SIZE; i++ )
		f[i] = 10;
	
	if ( DICE_sync_new("test", "longvec", f) != 0 )
		fprintf(stderr, "aaw");

	DICE_sync();

	max = 1; 
	for ( i = 0; i < max; i++ ) {
		for ( j = 0; j < VEC_SIZE; j++ ) 
			f[j]++;
		
		DICE_sync_update("test", f); 
		DICE_sync();
		g = DICE_sync_get("test");
		memcpy(f, g, VEC_SIZE*sizeof (long));
	} 

/*	for ( i = 0; i < VEC_SIZE; i++ )
		fprintf(stderr, "%d ", g[i]); */

	fprintf(stderr, "Test successful\n");
	DICE_close();
	return 0;
}
